#include <RF24Network.h>
#include <RF24.h>

#define num_max_objects 10
#define num_max_sensor 3
#define number_of_sensor 3
const int max_diference = 10;
const int max_diference_distance =30;
const float distancebetween1and2 = 60.0;
const float distancebetween2and3 = 75.0;

RF24 radio(7, 8);               // nRF24L01(+) radio attached using Getting Started board

RF24Network network(radio);      // Network uses that radio
const uint16_t this_node = 00;    // Address of our node in Octal format ( 04,031, etc)

struct struct_receceived {
  String str_points_detected;
  boolean used;
};
struct_receceived arrpositioning[num_max_objects+1] = {"",false};    // index = 1,2,3 are reserved for the sound sensor devices

struct struct_candidates {
  String str_points_candidates;
  int points_candidates;
};
struct_candidates arrcandidates[number_of_sensor+2] = {"",0};    // index = 1,2,3 are reserved for the sound sensor devices. index 4 for internal calculates

boolean object_registered[num_max_objects+1] = {false};

RF24NetworkHeader header;

char strreceived[50];
String item = "";

unsigned int next_object_to_send = 0;
boolean waiting_transmission = false;
const long millis_waiting_transmission = 5000;
long init_waiting;

void setup(void)
{

  Serial.begin(9600);

  radio.begin();
  radio.setPALevel(RF24_PA_MIN);
  radio.setDataRate(RF24_250KBPS);
  network.begin(/*channel*/ 70, /*node address*/ this_node);
  
  object_registered[1] = true;
  object_registered[2] = true;
  object_registered[3] = true;
  
}

boolean candidate_selected_between1and2(int distance, int angle, int object_id)
{
  
  boolean bool_continue = true;
  int posini = 0;
  if ((distance <= 0) or (angle <= 0)) return false;
  
  while (bool_continue) {
    int index = arrcandidates[1].str_points_candidates.indexOf(";",posini);
    String str_distance_angle_candidate = arrcandidates[1].str_points_candidates.substring(posini,index);
    if (index >= arrcandidates[1].str_points_candidates.length()-1) bool_continue = false;
    else posini = index+1;
    
    int distance_candidate = str_distance_angle_candidate.substring(0,str_distance_angle_candidate.indexOf(",")).toInt();
    int angle_candidate = str_distance_angle_candidate.substring(str_distance_angle_candidate.indexOf(",")+1,str_distance_angle_candidate.length()).toInt();

    // formula to check the ang
    float distancefroms2 = sin(radians(angle)) * distance;
    float distancefroms1 = cos(radians(angle_candidate)) * distance_candidate;

    if (abs(distancefroms2 + distancefroms1 - distancebetween1and2) <= float(max_diference_distance)) {
      
      Serial.print(angle_candidate);
      Serial.print(",");
      Serial.print(distance_candidate);
      Serial.print(";");
      Serial.print(object_id);
      Serial.print(":");
      Serial.print(1);
      Serial.print(".");
      
      return true;
    }
  } 
  return false;
}

void candidate_selected_between_sensor2and3 (int distance, int angle) {
  
  boolean bool_continue = true;
  int posini = 0;
  
  while (bool_continue) {
    int index = arrcandidates[3].str_points_candidates.indexOf(";",posini);
    String str_distance_angle_candidate = arrcandidates[3].str_points_candidates.substring(posini,index);
    if (index >= arrcandidates[3].str_points_candidates.length()-1) bool_continue = false;
    else posini = index+1;
    
    int distance_candidate = str_distance_angle_candidate.substring(0,str_distance_angle_candidate.indexOf(",")).toInt();
    int angle_candidate = str_distance_angle_candidate.substring(str_distance_angle_candidate.indexOf(",")+1,str_distance_angle_candidate.length()).toInt();
    
    float distancefroms2 = sin(radians(angle)) * distance;
    float distancefroms3 = cos(radians(angle_candidate)) * distance_candidate;


    if (abs(distancefroms2 + distancefroms3 - distancebetween2and3) <= float(max_diference_distance)) {
      arrcandidates[4].str_points_candidates = arrcandidates[4].str_points_candidates + distance + "," + angle + ";";
      arrcandidates[4].points_candidates += 1;

    }
    
  } 
}

void process_pointobject_with_pointssensor(String str_distance_angle_obj, int index_sensor) {
  boolean bool_continue = true;
  int posini = 0;

  int distance_obj = str_distance_angle_obj.substring(0,str_distance_angle_obj.indexOf(",")).toInt();
  int angle_obj = str_distance_angle_obj.substring(str_distance_angle_obj.indexOf(",")+1,str_distance_angle_obj.length()).toInt();


  while (bool_continue) {
    int index = arrpositioning[index_sensor].str_points_detected.indexOf(";",posini);
    String str_distance_angle_sensor = arrpositioning[index_sensor].str_points_detected.substring(posini,index);
    if (index >= arrpositioning[index_sensor].str_points_detected.length()-1) bool_continue = false;
    else posini = index+1;
    
    int distance_sensor = str_distance_angle_sensor.substring(0,str_distance_angle_sensor.indexOf(",")).toInt();
    int angle_sensor = str_distance_angle_sensor.substring(str_distance_angle_sensor.indexOf(",")+1,str_distance_angle_sensor.length()).toInt();

    if (abs(distance_obj-distance_sensor) <= max_diference) {
      
      if (index_sensor == 1) {
        if (not ((distance_sensor > distancebetween1and2-10) and (angle_sensor > 80))) {
          arrcandidates[index_sensor].str_points_candidates = arrcandidates[index_sensor].str_points_candidates + str_distance_angle_sensor + ";";
          arrcandidates[index_sensor].points_candidates += 1;
        }
      } 
      if (index_sensor == 2) {
        if ((not ((distance_sensor > distancebetween1and2-10) and (angle_sensor < 15))) and
            (not ((distance_sensor > distancebetween2and3-10) and (angle_sensor > 80)))) {
          arrcandidates[index_sensor].str_points_candidates = arrcandidates[index_sensor].str_points_candidates + str_distance_angle_sensor + ";";
          arrcandidates[index_sensor].points_candidates += 1;
        }
      }
      if (index_sensor == 3) {
        if (not ((distance_sensor > distancebetween2and3-10) and (angle_sensor < 15))) {
          arrcandidates[index_sensor].str_points_candidates = arrcandidates[index_sensor].str_points_candidates + str_distance_angle_sensor + ";";
          arrcandidates[index_sensor].points_candidates += 1;
        }
      } 

    };

  } 
}

void process_positioning(struct_receceived structobject, int object_id) {
  boolean bool_continue = true;
  int posini = 0;

  while (bool_continue) {
    int index = structobject.str_points_detected.indexOf(";",posini);
    String strpos_distance_angle = structobject.str_points_detected.substring(posini,index);
    if (index >= structobject.str_points_detected.length()-1) bool_continue = false;
    else posini = index+1;
    //Serial.println(strpos_distance_angle);
    for (int index_sensor=1; index_sensor <= number_of_sensor; index_sensor++)
      process_pointobject_with_pointssensor(strpos_distance_angle,index_sensor);
  }

  if ((number_of_sensor > 1) and (arrcandidates[2].points_candidates >= 1) and 
  (arrcandidates[3].points_candidates >= 1)) {
    bool_continue = true;
    posini = 0;
    while (bool_continue) {
      int index = arrcandidates[2].str_points_candidates.indexOf(";",posini);
      String str_distance_angle_candidate = arrcandidates[2].str_points_candidates.substring(posini,index);
      if (index >= arrcandidates[2].str_points_candidates.length()-1) bool_continue = false;
      else posini = index+1;
      
      int distance_candidate = str_distance_angle_candidate.substring(0,str_distance_angle_candidate.indexOf(",")).toInt();
      int angle_candidate = str_distance_angle_candidate.substring(str_distance_angle_candidate.indexOf(",")+1,str_distance_angle_candidate.length()).toInt();
      
      candidate_selected_between_sensor2and3(distance_candidate,angle_candidate);
    }
    bool_continue = true;
    posini = 0;
    while ((bool_continue) and (arrcandidates[4].points_candidates >= 1) 
          and (arrcandidates[1].points_candidates >= 1)) {
      int index = arrcandidates[4].str_points_candidates.indexOf(";",posini);
      String str_distance_angle_candidate = arrcandidates[4].str_points_candidates.substring(posini,index);
      if (index >= arrcandidates[4].str_points_candidates.length()-1) bool_continue = false;
      else posini = index+1;
      
      int distance_candidate = str_distance_angle_candidate.substring(0,str_distance_angle_candidate.indexOf(",")).toInt();
      int angle_candidate = str_distance_angle_candidate.substring(str_distance_angle_candidate.indexOf(",")+1,str_distance_angle_candidate.length()).toInt();
      
      if (candidate_selected_between1and2(distance_candidate,angle_candidate,object_id)) {
        bool_continue = false;
      }
    }
  }
  
  for (int index=1;index<=number_of_sensor;index++) {
    arrcandidates[index].points_candidates = 0;
    arrcandidates[index].str_points_candidates = "";
  }
  arrcandidates[4].points_candidates = 0;
  arrcandidates[4].str_points_candidates = "";
  
}

void send_signal(unsigned int next_object_to_send){
  network.update();
  for (int inode = 1; inode <= num_max_objects; inode++) {
    if (object_registered[inode]) {
      header.to_node = inode;
      network.write(header,&next_object_to_send,sizeof(next_object_to_send));
    }
  }
}

void loop(void) {

  
  if (waiting_transmission and ((millis()-init_waiting) > millis_waiting_transmission)) {
    waiting_transmission = false;
  }
  
  if (not waiting_transmission) {
    bool continue_iteration = true;
    for (int index_object=next_object_to_send+1; ((continue_iteration) and (index_object<=num_max_objects)); index_object++) {
        if (object_registered[index_object]) {
          next_object_to_send = index_object;
          continue_iteration = false;
        }
    }
    if (continue_iteration) {
      for (int index_object=1; ((continue_iteration) and (index_object<=num_max_objects)); index_object++) {
          if (object_registered[index_object]) {
            next_object_to_send = index_object;
            continue_iteration = false;
          }
      }
    }
    if (next_object_to_send > 0) {
      send_signal(next_object_to_send);
      waiting_transmission = true;
      init_waiting = millis();
    }
  }

  network.update();                  // Check the network regularly
  while ( network.available() ) {     // Is there anything ready for us?
    network.read(header, &strreceived, sizeof(strreceived));
    item = "";
    for (int k = 0; ((k < 50) and not (int(strreceived[k]) == 58)); k++) item += strreceived[k];
    int index = item.substring(0,item.indexOf("#")).toInt();
    String strpointsdetected = item.substring(item.indexOf("#")+1,item.length());
    if ((index > 0) and (index <= num_max_objects)) {
      if (strpointsdetected == "RECOGNITION") {
        object_registered[index] = true;
        return;
      }
      
      if (index == next_object_to_send) waiting_transmission = false;
      
      arrpositioning[index].used = true;
      arrpositioning[index].str_points_detected = strpointsdetected;
      
    }
  }
  boolean all_sensors_received = true;
  for (int index_sensor=1; index_sensor <= number_of_sensor; index_sensor++) if (not (arrpositioning[index_sensor].used)) all_sensors_received = false;
  
  if (all_sensors_received) {
    for (int index_object=number_of_sensor+1; index_object <= num_max_objects; index_object++) {
      if (arrpositioning[index_object].used) {
        process_positioning(arrpositioning[index_object], index_object);
        arrpositioning[index_object].used = false;
      }
    }
  }
}
